----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:29:29 08/28/2009 
-- Design Name: 
-- Module Name:    TxD - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity TxD_1 is
	Port ( 	CLK : in std_logic;   -- 50 MHz Takt
				TxD : out std_logic;   
				swt_in: in std_logic_vector(7 downto 0)

			); 
end TxD_1;

architecture Behavioral of TxD_1 is
	signal StateS: integer;
	signal busyS: std_logic;
   signal Cnt : integer;
	signal Baud,luck : std_logic;
begin

	process(CLK)
		variable ClkDivS: std_logic_vector(3 downto 0);
      variable ClkDiv: std_logic_vector(3 downto 0);
   begin
      if CLK'event and CLK='1' then
		if cnt<=1302 then
		cnt<=cnt+1;
		else
		Baud<=not(Baud);
		Cnt<=0;
		end if;
		end if;
		end process;


process(Baud)

begin

if Baud='1' and Baud'event then
				StateS<=StateS+1;
			  case StateS is
				  when 0=>			
					 TxD<='0';		
				  when 1=>  			
					 TxD<=swt_in(0);
				  when 2=>
					 TxD<=swt_in(1);
				  when 3=>
					 TxD<=swt_in(2);
				  when 4=>
					 TxD<=swt_in(3);
				  when 5=>
					 TxD<=swt_in(4);
				  when 6=>
					 TxD<=swt_in(5);
				  when 7=>
					 TxD<=swt_in(6);
				  when 8=>
					 TxD<=swt_in(7);
				  when 9 =>				
					 TxD<='1';		
				  when others =>

						 StateS<=0;

				end case;
				end if;
				
				
end process;

end Behavioral;

